<script lang="ts" setup>
import BasePageableTable from "@/components/base/base-pageable-table/BasePageableTable.vue";
import DefaultToolButton from "@/components/base/default-tool-button/DefaultToolButton.vue";
import DefaultOperateButtonColumn from "@/components/base/default-column/DefaultOperateButtonColumn.vue";
import { usePage } from "@/composables/use-page";
import BaseForm from "@/components/base/base-form/BaseForm.vue";
import { $t } from "@/common/languages";
import type { FormInstance, FormRules } from "element-plus";

/**
 * 必须要的变量
 */

const getPageUrl = "/sys/syspermission/getSysPermissionPage";
const addUrl = "/sys/syspermission/addSysPermission";
const editUrl = "/sys/syspermission/updateSysPermission";
const removeUrl = "/sys/syspermission/deleteSysPermission";
const searchers = [
  { name: "permissionName", type: "text" as const, placeholder: $t("_prop.systemset.syspermission.permissionName") },
];
const rules = reactive<FormRules>({});
/**
 * 基本不变通用变量
 */
const tableRef = ref<InstanceType<typeof BasePageableTable> | null>(null);
const { useAdd, useEdit, useRemove, useGeneralPageRef } = usePage(tableRef);
const { title, visible, formType, form } = useGeneralPageRef();
/**
 * 可以自定义的变量
 */

const add = () => {
  form.value = {};
  title.value = "_title.systemset.syspermission.add";
  visible.value = true;
  formType.value = false;
};
const edit = (row: any) => {
  title.value = "_title.systemset.syspermission.edit";
  form.value = { ...row };
  visible.value = true;
  formType.value = true;
};
const remove = (row: any) => {
  useRemove(removeUrl, row.id, "_message.systemset.syspermission.delete_message");
};
const submit = (form: any, formRef: FormInstance | undefined) => {
  if (formRef !== undefined) {
    formRef.validate(valid => {
      if (valid) {
        if (formType.value) useEdit(editUrl, form, visible);
        else useAdd(addUrl, form, visible);
      }
    });
  }
};
const topButtonClick = (eventName: string) => {
  switch (eventName) {
    case "add":
      add();
      break;
  }
};
const operateButtonClick = (eventName: string, row: any) => {
  switch (eventName) {
    case "edit":
      edit(row);
      break;
    case "remove":
      remove(row);
      break;
  }
};
</script>
<template>
  <BasePageableTable :url="getPageUrl" :searchers="searchers" ref="tableRef">
    <template #tool-button>
      <DefaultToolButton @top-button-click="topButtonClick" />
    </template>
    <template #columns>
      <el-table-column prop="id" type="hidden" width="40" />
      <el-table-column :label="$t('_prop.systemset.syspermission.permissionName')" prop="permissionName" />
      <el-table-column :label="$t('_prop.systemset.syspermission.pageLink')" prop="pageLink" />
      <el-table-column :label="$t('_prop.systemset.syspermission.eventName')" prop="eventName" />
      <el-table-column :label="$t('_prop.systemset.syspermission.iconName')" prop="iconName" />
      <el-table-column :label="$t('_prop.systemset.syspermission.permissionType')" prop="permissionType" />
      <el-table-column :label="$t('_prop.systemset.syspermission.sort')" prop="sort" />
      <el-table-column :label="$t('_prop.common.status')" prop="status" />
      <DefaultOperateButtonColumn @operate-button-click="operateButtonClick" />
    </template>
  </BasePageableTable>
  <BaseForm v-model:visible="visible" @submit="submit" v-model:form="form" :title="$t(title)" :rules="rules">
    <template #form-items>
      <el-form-item prop="id" v-if="false"><el-input v-model="form.id" /></el-form-item>
    </template>
  </BaseForm>
</template>
